\documentclass[a4paper]{book}
\usepackage[times,inconsolata,hyper]{Rd}
\usepackage{makeidx}
\usepackage[utf8,latin1]{inputenc}
% \usepackage{graphicx} % @USE GRAPHICX@
\makeindex{}
\begin{document}
\chapter*{}
\begin{center}
{\textbf{\huge Package `MDPtoolbox'}}
\par\bigskip{\large \today}
\end{center}
\begin{description}
\raggedright{}
\item[Type]\AsIs{Package}
\item[Title]\AsIs{Markov Decision Processes toolbox}
\item[Version]\AsIs{4.0.1}
\item[Date]\AsIs{2012-12-31}
\item[Author]\AsIs{Iadine Chades, Guillaume Chapron, Marie-Josee Cros, Frederick Garcia, Regis Sabbadin}
\item[Maintainer]\AsIs{Guillaume Chapron }\email{gchapron@carnivoreconservation.org}\AsIs{}
\item[Description]\AsIs{The Markov Decision Processes (MDP) toolbox proposes functions related to the resolution of discrete-time Markov Decision Processes: finite horizon, value iteration, policy iteration, linear programming algorithms with some variants and also proposes some functions related to Reinforcement Learning.}
\item[License]\AsIs{BSD}
\item[Depends]\AsIs{Matrix, linprog}
\end{description}
\Rdcontents{\R{} topics documented:}
\inputencoding{utf8}
\HeaderA{MDPtoolbox-package}{Markov Decision Processes toolbox}{MDPtoolbox.Rdash.package}
\aliasA{MDPtoolbox}{MDPtoolbox-package}{MDPtoolbox}
%
\begin{Description}\relax
The Markov Decision Processes (MDP) toolbox proposes functions related to the resolution of discrete-time Markov Decision Processes: finite horizon, value iteration, policy iteration, linear programming algorithms with some variants  and also proposes some functions related to Reinforcement Learning.
\end{Description}
%
\begin{Details}\relax

\Tabular{ll}{
Package: & MDPtoolbox\\{}
Type: & Package\\{}
Version: & 4.0.1\\{}
Date: & 2012-12-31\\{}
License: & BSD (4.4)\\{}
}
\end{Details}
%
\begin{Author}\relax

Iadine Chadès <Iadine.Chades@csiro.au>\\{}
Guillaume Chapron <gchapron@carnivoreconservation.org>\\{}
Marie-Josée Cros <Marie-Josee.Cros@toulouse.inra.fr>\\{}
Fredérick Garcia <fgarcia@toulouse.inra.fr>\\{}
Régis Sabbadin <Regis.Sabbadin@toulouse.inra.fr> \\{}

\end{Author}
%
\begin{References}\relax
Chadès, I et al. 2012. MDP Toolbox: a multi-platform toolbox to solve stochastic dynamic pro- gramming problems. \\{}
Puterman, M. L. 1994. Markov Decision Processes. John Wiley \& Sons, New-York.

\end{References}
%
\begin{Examples}
\begin{ExampleCode}
# Generates a random MDP problem
set.seed(0)
mdp_example_rand(2, 2)
mdp_example_rand(2, 2, FALSE)
mdp_example_rand(2, 2, TRUE)
mdp_example_rand(2, 2, FALSE, matrix(c(1,0,1,1),2,2))

# Generates a MDP for a simple forest management problem
MDP <- mdp_example_forest()

# Find an optimal policy
results <- mdp_policy_iteration(MDP$P, MDP$R, 0.9)

# Visualise the policy
results$policy

\end{ExampleCode}
\end{Examples}
\inputencoding{utf8}
\HeaderA{mdp\_bellman\_operator}{Applies the Bellman operator}{mdp.Rul.bellman.Rul.operator}
%
\begin{Description}\relax
Applies the Bellman operator to a value function Vprev and returns a new value function and a Vprev-improving policy.
\end{Description}
%
\begin{Usage}
\begin{verbatim}
mdp_bellman_operator(P, PR, discount, Vprev)
\end{verbatim}
\end{Usage}
%
\begin{Arguments}
\begin{ldescription}
\item[\code{P}] 
transition probability array. P can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S].

\item[\code{PR}] 
reward array. PR can be a 2 dimension array [S,A] possibly sparse.

\item[\code{discount}] 
discount factor. discount is a real number belonging to ]0; 1].

\item[\code{Vprev}] 
value fonction. Vprev is a vector of length S.

\end{ldescription}
\end{Arguments}
%
\begin{Details}\relax
mdp\_bellman\_operator applies the Bellman operator: PR + discount*P*Vprev to the value function Vprev. Returns a new value function and a Vprev-improving policy.
\end{Details}
%
\begin{Value}

\begin{ldescription}
\item[\code{V}] new value fonction. V is a vector of length S.
\item[\code{policy}] policy is a vector of length S. Each element is an integer corresponding to an action.

\end{ldescription}
\end{Value}
%
\begin{Examples}
\begin{ExampleCode}

# With a non-sparse matrix
P <- array(0, c(2,2,2))
P[,,1] <- matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE)
P[,,2] <- matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE)
R <- matrix(c(5, 10, -1, 2), 2, 2, byrow=TRUE)
mdp_bellman_operator(P, R, 0.9, c(0,0))

# With a sparse matrix
P <- list()
P[[1]] <- Matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE, sparse=TRUE)
P[[2]] <- Matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE, sparse=TRUE)
mdp_bellman_operator(P, R, 0.9, c(0,0))

\end{ExampleCode}
\end{Examples}
\inputencoding{utf8}
\HeaderA{mdp\_check}{Checks the validity of a MDP}{mdp.Rul.check}
%
\begin{Description}\relax
Checks the validity of a MDP
\end{Description}
%
\begin{Usage}
\begin{verbatim}
mdp_check(P, R)
\end{verbatim}
\end{Usage}
%
\begin{Arguments}
\begin{ldescription}
\item[\code{P}] 
transition probability array. P can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S].

\item[\code{R}] 
reward array. R can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S] or a 2 dimensional matrix [S,A] possibly sparse.

\end{ldescription}
\end{Arguments}
%
\begin{Details}\relax
mdp\_check checks whether the MDP defined by the transition probability array (P) and the reward matrix (R) is valid. If P and R are correct, the function returns an empty error message. In the opposite case, the function returns an error message describing the problem.
\end{Details}
%
\begin{Value}
Returns a character string which is empty if the MDP is valid. In the opposite case, the variable contains problem information
\end{Value}
%
\begin{Examples}
\begin{ExampleCode}
# With a non-sparse matrix
P <- array(0, c(2,2,2))
P[,,1] <- matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE)
P[,,2] <- matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE)
R <- matrix(c(5, 10, -1, 2), 2, 2, byrow=TRUE)
mdp_check(P, R)

# With a sparse matrix
P <- list()
P[[1]] <- Matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE, sparse=TRUE)
P[[2]] <- Matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE, sparse=TRUE)
mdp_check(P, R)
\end{ExampleCode}
\end{Examples}
\inputencoding{utf8}
\HeaderA{mdp\_check\_square\_stochastic}{Checks if a matrix is square and stochastic}{mdp.Rul.check.Rul.square.Rul.stochastic}
%
\begin{Description}\relax
Checks whether a matrix is square and stochastic
\end{Description}
%
\begin{Usage}
\begin{verbatim}
mdp_check_square_stochastic(X)
\end{verbatim}
\end{Usage}
%
\begin{Arguments}
\begin{ldescription}
\item[\code{X}] a matrix
\end{ldescription}
\end{Arguments}
%
\begin{Details}\relax
mdp\_check\_square\_stochastic checks if the matrix (X) is square and stochastic (sums of rows equal to 1).
If it is the case, the function returns an empty error message. In the opposite case, the function returns an error message describing the problem.
\end{Details}
%
\begin{Value}
Returns a character string which is empty if the matrix is square and stochastic. In the opposite case, the variable contains problem information.
\end{Value}
%
\begin{Examples}
\begin{ExampleCode}
M <- matrix(c(0.6116, 0.3884, 0, 1.0000), 2, 2, byrow=TRUE)

mdp_check_square_stochastic(M)
\end{ExampleCode}
\end{Examples}
\inputencoding{utf8}
\HeaderA{mdp\_computePpolicyPRpolicy}{Computes the transition matrix and the reward matrix for a fixed policy}{mdp.Rul.computePpolicyPRpolicy}
%
\begin{Description}\relax
Computes the transition matrix and the reward matrix for a given policy.
\end{Description}
%
\begin{Usage}
\begin{verbatim}
mdp_computePpolicyPRpolicy(P, R, policy)
\end{verbatim}
\end{Usage}
%
\begin{Arguments}
\begin{ldescription}
\item[\code{P}] 
transition probability array. P can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S].

\item[\code{R}] 
reward array. R can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S] or a 2 dimensional matrix [S,A] possibly sparse.

\item[\code{policy}] 
a policy. policy is a length S vector of integer representing actions.

\end{ldescription}
\end{Arguments}
%
\begin{Details}\relax
mdp\_computePpolicyPRpolicy computes the state transition matrix and the reward matrix of a policy, given a probability matrix P and a reward matrix.
\end{Details}
%
\begin{Value}
\begin{ldescription}
\item[\code{Ppolicy}] transition probability array of the policy. Ppolicy is a [S,S] matrix.
\item[\code{PRpolicy}] reward matrix of the policy. PRpolicy is a vector of length S.

\end{ldescription}
\end{Value}
%
\begin{Examples}
\begin{ExampleCode}

# With a non-sparse matrix
P <- array(0, c(2,2,2))
P[,,1] <- matrix(c(0.6116, 0.3884, 0, 1.0000), 2, 2, byrow=TRUE)
P[,,2] <- matrix(c(0.6674, 0.3326, 0, 1.0000), 2, 2, byrow=TRUE)
R <- array(0, c(2,2,2))
R[,,1] <- matrix(c(-0.2433, 0.7073, 0, 0.1871), 2, 2, byrow=TRUE)
R[,,2] <- matrix(c(-0.0069, 0.6433, 0, 0.2898), 2, 2, byrow=TRUE)
policy <- c(2,2)
mdp_computePpolicyPRpolicy(P, R, policy)

# With a sparse matrix (P)
P <- list()
P[[1]] <- Matrix(c(0.6116, 0.3884, 0, 1.0000), 2, 2, byrow=TRUE, sparse=TRUE)
P[[2]] <- Matrix(c(0.6674, 0.3326, 0, 1.0000), 2, 2, byrow=TRUE, sparse=TRUE)
mdp_computePpolicyPRpolicy(P, R, policy)
\end{ExampleCode}
\end{Examples}
\inputencoding{utf8}
\HeaderA{mdp\_computePR}{Computes a reward matrix for any form of transition and reward functions}{mdp.Rul.computePR}
%
\begin{Description}\relax
Computes the reward associated to a state/action pair.
\end{Description}
%
\begin{Usage}
\begin{verbatim}
mdp_computePR(P, R)
\end{verbatim}
\end{Usage}
%
\begin{Arguments}
\begin{ldescription}
\item[\code{P}] 
transition probability array. P can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S].

\item[\code{R}] 
reward array. R can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S] or a 2 dimensional matrix [S,A] possibly sparse.

\end{ldescription}
\end{Arguments}
%
\begin{Details}\relax
mdp\_computePR computes the reward of a state/action pair, given a probability array P and a reward array possibly depending on arrival state.
\end{Details}
%
\begin{Value}

\begin{ldescription}
\item[\code{PR}] reward matrix. PR is a [S,A] matrix.

\end{ldescription}
\end{Value}
%
\begin{Examples}
\begin{ExampleCode}
# With a non-sparse matrix
P <- array(0, c(2,2,2))
P[,,1] <- matrix(c(0.6116, 0.3884, 0, 1.0000), 2, 2, byrow=TRUE)
P[,,2] <- matrix(c(0.6674, 0.3326, 0, 1.0000), 2, 2, byrow=TRUE)
R <- array(0, c(2,2,2))
R[,,1] <- matrix(c(-0.2433, 0.7073, 0, 0.1871), 2, 2, byrow=TRUE)
R[,,2] <- matrix(c(-0.0069, 0.6433, 0, 0.2898), 2, 2, byrow=TRUE)
mdp_computePR(P, R)

# With a sparse matrix (P)
P <- list()
P[[1]] <- Matrix(c(0.6116, 0.3884, 0, 1.0000), 2, 2, byrow=TRUE, sparse=TRUE)
P[[2]] <- Matrix(c(0.6674, 0.3326, 0, 1.0000), 2, 2, byrow=TRUE, sparse=TRUE)
mdp_computePR(P, R)

\end{ExampleCode}
\end{Examples}
\inputencoding{utf8}
\HeaderA{mdp\_eval\_policy\_iterative}{Evaluates a policy using an iterative method}{mdp.Rul.eval.Rul.policy.Rul.iterative}
%
\begin{Description}\relax
Evaluates a policy using iterations of the Bellman operator
\end{Description}
%
\begin{Usage}
\begin{verbatim}
mdp_eval_policy_iterative(P, R, discount, policy, V0, epsilon, max_iter)
\end{verbatim}
\end{Usage}
%
\begin{Arguments}
\begin{ldescription}
\item[\code{P}] 
transition probability array. P can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S].

\item[\code{R}] 
reward array. R can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S] or a 2 dimensional matrix [S,A] possibly sparse.

\item[\code{discount}] 
discount factor. discount is a real number which belongs to [0; 1[.

\item[\code{policy}] 
a policy. policy is a S length vector. Each element is an integer corresponding
to an action.

\item[\code{V0}] 
(optional) starting point. V0 is a S length vector representing an inital guess of the value function. By default, V0 is only composed of 0 elements.

\item[\code{epsilon}] 
(optional) search for an epsilon-optimal policy. epsilon is a real greater than 0. By default, epsilon = 0.01.

\item[\code{max\_iter}] 
(optional) maximum number of iterations. max\_iter is an integer greater than 0. If the value given in argument is greater than a computed bound, a warning informs that the computed bound will be used instead. By default, max\_iter = 1000.

\end{ldescription}
\end{Arguments}
%
\begin{Details}\relax
mdp\_eval\_policy\_iterative evaluates the value fonction associated to a policy applying iteratively the Bellman operator.
\end{Details}
%
\begin{Value}


\begin{ldescription}
\item[\code{Vpolicy}] value fonction. Vpolicy is a S length vector.
\end{ldescription}


\end{Value}
%
\begin{Examples}
\begin{ExampleCode}
# With a non-sparse matrix
P <- array(0, c(2,2,2))
P[,,1] <- matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE)
P[,,2] <- matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE)
R <- matrix(c(5, 10, -1, 2), 2, 2, byrow=TRUE)
policy <- c(2,1)
mdp_eval_policy_iterative(P, R, 0.8, policy)

# With a sparse matrix
P <- list()
P[[1]] <- Matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE, sparse=TRUE)
P[[2]] <- Matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE, sparse=TRUE)
mdp_eval_policy_iterative(P, R, 0.8, policy)

\end{ExampleCode}
\end{Examples}
\inputencoding{utf8}
\HeaderA{mdp\_eval\_policy\_matrix}{Evaluates a policy using matrix inversion and product}{mdp.Rul.eval.Rul.policy.Rul.matrix}
%
\begin{Description}\relax
Evaluates a policy using matrix operation
\end{Description}
%
\begin{Usage}
\begin{verbatim}
mdp_eval_policy_matrix(P, R, discount, policy)
\end{verbatim}
\end{Usage}
%
\begin{Arguments}
\begin{ldescription}
\item[\code{P}] 
transition probability array. P can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S].

\item[\code{R}] 
reward array. R can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S] or a 2 dimensional matrix [S,A] possibly sparse.

\item[\code{discount}] 
discount factor. discount is a real number which belongs to [0; 1[.

\item[\code{policy}] 
a policy. policy is a S length vector. Each element is an integer corresponding
to an action.
\end{ldescription}
\end{Arguments}
%
\begin{Details}\relax
mdp\_eval\_policy\_matrix evaluates the value fonction associated with a policy
\end{Details}
%
\begin{Value}


\begin{ldescription}
\item[\code{Vpolicy }] value fonction. Vpolicy is a S length vector
\end{ldescription}


\end{Value}
%
\begin{Examples}
\begin{ExampleCode}
# With a non-sparse matrix
P <- array(0, c(2,2,2))
P[,,1] <- matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE)
P[,,2] <- matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE)
R <- matrix(c(5, 10, -1, 2), 2, 2, byrow=TRUE)
mdp_eval_policy_matrix(P, R, 0.9, c(1,2))

# With a sparse matrix
P <- list()
P[[1]] <- Matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE, sparse=TRUE)
P[[2]] <- Matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE, sparse=TRUE)
mdp_eval_policy_matrix(P, R, 0.9, c(1,2))

\end{ExampleCode}
\end{Examples}
\inputencoding{utf8}
\HeaderA{mdp\_eval\_policy\_optimality}{Computes sets of 'near optimal' actions for each state}{mdp.Rul.eval.Rul.policy.Rul.optimality}
%
\begin{Description}\relax
Determines sets of 'near optimal' actions for all states
\end{Description}
%
\begin{Usage}
\begin{verbatim}
mdp_eval_policy_optimality(P, R, discount, Vpolicy)
\end{verbatim}
\end{Usage}
%
\begin{Arguments}
\begin{ldescription}
\item[\code{P}] 
transition probability array. P can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S].

\item[\code{R}] 
reward array. R can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S] or a 2 dimensional matrix [S,A] possibly sparse.

\item[\code{discount}] 
discount factor. discount is a real number which belongs to [0; 1[.

\item[\code{Vpolicy}] 
value function of the optimal policy. Vpolicy is a S length vector.

\end{ldescription}
\end{Arguments}
%
\begin{Details}\relax
For some states, the evaluation of the value function may give close results for different actions. It is interesting to identify those states for which several actions have a value function very close the optimal one (i.e. less than 0.01 different). We called this the search for near optimal actions in each state.
\end{Details}
%
\begin{Value}


\begin{ldescription}
\item[\code{multiple}] existence of at least two 'nearly' optimal actions for a state.
multiple is egal to true when at least one state has several epsilon-optimal actions, false if not.
\item[\code{optimal\_actions }] actions 'nearly' optimal for each state. optimal\_actions is a [S,A] boolean matrix whose element optimal\_actions(s, a) is true if the action a is 'nearly' optimal being in state s and false if not.
\end{ldescription}

\end{Value}
%
\begin{Examples}
\begin{ExampleCode}
# With a non-sparse matrix
P <- array(0, c(2,2,2))
P[,,1] <- matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE)
P[,,2] <- matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE)
R <- matrix(c(5, 10, -1, 2), 2, 2, byrow=TRUE)
Vpolicy <- c(42.4419, 36.0465)
mdp_eval_policy_optimality(P, R, 0.9, Vpolicy)

# With a sparse matrix
P <- list()
P[[1]] <- Matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE, sparse=TRUE)
P[[2]] <- Matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE, sparse=TRUE)
mdp_eval_policy_optimality(P, R, 0.9, Vpolicy)

\end{ExampleCode}
\end{Examples}
\inputencoding{utf8}
\HeaderA{mdp\_eval\_policy\_TD\_0}{Evaluates a policy using the TD(0) algorithm}{mdp.Rul.eval.Rul.policy.Rul.TD.Rul.0}
%
\begin{Description}\relax
Evaluates a policy using the TD(0) algorithm
\end{Description}
%
\begin{Usage}
\begin{verbatim}
mdp_eval_policy_TD_0(P, R, discount, policy, N)
\end{verbatim}
\end{Usage}
%
\begin{Arguments}
\begin{ldescription}
\item[\code{P}] 
transition probability array. P can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S].

\item[\code{R}] 
reward array. R can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S] or a 2 dimensional matrix [S,A] possibly sparse.

\item[\code{discount}] 
discount factor. discount is a real number which belongs to [0; 1[.

\item[\code{policy}] 
a policy. policy is a S length vector. Each element is an integer corresponding
to an action.

\item[\code{N}] (optional) number of iterations to perform. N is an integer greater than the de- fault value. By default, N is set to 10000

\end{ldescription}
\end{Arguments}
%
\begin{Details}\relax
mdp\_eval\_policy\_TD\_0 evaluates the value fonction associated to a policy using the TD(0) algorithm (Reinforcement Learning).
\end{Details}
%
\begin{Value}


\begin{ldescription}
\item[\code{Vpolicy}] value fonction. Vpolicy is a length S vector.
\end{ldescription}


\end{Value}
%
\begin{Examples}
\begin{ExampleCode}
# With a non-sparse matrix
P <- array(0, c(2,2,2))
P[,,1] <- matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE)
P[,,2] <- matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE)
R <- matrix(c(5, 10, -1, 2), 2, 2, byrow=TRUE)
mdp_eval_policy_TD_0(P, R, 0.9, c(1,2))

# With a sparse matrix
P <- list()
P[[1]] <- Matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE, sparse=TRUE)
P[[2]] <- Matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE, sparse=TRUE)
mdp_eval_policy_TD_0(P, R, 0.9, c(1,2))

\end{ExampleCode}
\end{Examples}
\inputencoding{utf8}
\HeaderA{mdp\_example\_forest}{Generates a MDP for a simple forest management problem}{mdp.Rul.example.Rul.forest}
%
\begin{Description}\relax
Generates a simple MDP example of forest management problem
\end{Description}
%
\begin{Usage}
\begin{verbatim}
mdp_example_forest(S, r1, r2, p)
\end{verbatim}
\end{Usage}
%
\begin{Arguments}
\begin{ldescription}
\item[\code{S}] 
(optional) number of states. S is an integer greater than 0. By default, S is set to 3.

\item[\code{r1}] 
(optional) reward when forest is in the oldest state and action Wait is performed. r1 is a real greater than 0. By default, r1 is set to 4.

\item[\code{r2}] 
(optional) reward when forest is in the oldest state and action Cut is performed
r2 is a real greater than 0. By default, r2 is set to 2.

\item[\code{p}] 
(optional) probability of wildfire occurence. p is a real in ]0, 1[. By default, p is set to 0.1.

\end{ldescription}
\end{Arguments}
%
\begin{Details}\relax
mdp\_example\_forest generates a transition probability (SxSxA) array P and a reward (SxA) matrix R that model the following problem.
A forest is managed by two actions: Wait and Cut.
An action is decided each year with first the objective to maintain an old forest for wildlife and second to make money selling cut wood. 
Each year there is a probability p that a fire burns the forest.

Here is the modelisation of this problem.
Let 1, ... S be the states of the forest. the Sth state being the oldest.
Let Wait be action 1 and Cut action 2.
After a fire, the forest is in the youngest state, that is state 1.

The transition matrix P of the problem can then be defined as follows:

\deqn{ P(,,1) = \left[
					\begin{array}{llllll}
					p & 1-p & 0 & \ldots & \ldots & 0 \\
					p & 0 & 1-p & 0 & \ldots & 0 \\
					\vdots & \vdots & \vdots & \ddots & \ddots & \vdots \\
					\vdots & \vdots & \vdots & \ddots & \ddots & 0 \\
					\vdots & \vdots & \vdots & \ddots & \ddots & 1-p \\
					p & 0 & 0 & \ldots & 0 & 1-p \\
					\end{array}
				\right] }{}

\deqn{ P(,,2) = \left[
					\begin{array}{lllll}
					1 & 0 & \ldots & \ldots & 0 \\
					\vdots & \vdots & \ddots & \ddots & \vdots \\
					\vdots & \vdots & \ddots & \ddots & \vdots \\
					1 & 0 & \ldots & \ldots & 0 \\
					\end{array}
				\right] }{}

The reward matrix R is defined as follows:

\deqn{ R(,1) = \left[
					\begin{array}{l}
					0 \\
					\vdots \\
					\vdots \\
					\vdots \\
					0 \\
					r1 \\
					\end{array}
				\right] }{}

\deqn{ R(,2) = \left[
					\begin{array}{l}
					0 \\
					1 \\
					\vdots \\
					\vdots \\
					1 \\
					r2 \\
					\end{array}
				\right] }{}

\end{Details}
%
\begin{Value}

\begin{ldescription}
\item[\code{P}] transition probability array. P is a [S,S,A] array.
\item[\code{R}] reward matrix. R is a [S,A] matrix

\end{ldescription}
\end{Value}
%
\begin{Examples}
\begin{ExampleCode}
mdp_example_forest()
\end{ExampleCode}
\end{Examples}
\inputencoding{utf8}
\HeaderA{mdp\_example\_rand}{Generates a random MDP problem}{mdp.Rul.example.Rul.rand}
%
\begin{Description}\relax
Generates a random MDP problem
\end{Description}
%
\begin{Usage}
\begin{verbatim}
mdp_example_rand(S, A, is_sparse, mask)
\end{verbatim}
\end{Usage}
%
\begin{Arguments}
\begin{ldescription}
\item[\code{S}] 
number of states. S is an integer greater than 0

\item[\code{A}] 
number of actions. A is an integer greater than 0

\item[\code{is\_sparse}] 
(optional) used to generate sparse matrices. is\_sparse is a boolean. If it is set to true, sparse matrices are generated. By default, it is set to false.

\item[\code{mask}] 
(optional) indicates the possible transitions between states. mask is a [S,S] ma- trix composed of 0 and 1 elements (0 indicates a transition probability always equal to zero). By default, mask is only composed of 1.

\end{ldescription}
\end{Arguments}
%
\begin{Details}\relax
mdp\_example\_rand generates a transition probability matrix (P) and a reward matrix (R). Optional arguments allow to define sparse matrices and pairs of states with impossible transitions.
\end{Details}
%
\begin{Value}


\begin{ldescription}
\item[\code{P}] transition probability array. P can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S].
\item[\code{R }] reward array. R can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S]. Elements of R are in ]-1; 1[
\end{ldescription}

\end{Value}
%
\begin{Examples}
\begin{ExampleCode}
mdp_example_rand(2, 2)
mdp_example_rand(2, 2, FALSE)
mdp_example_rand(2, 2, TRUE)
mdp_example_rand(2, 2, FALSE, matrix(c(1,0,1,1),2,2))

\end{ExampleCode}
\end{Examples}
\inputencoding{utf8}
\HeaderA{mdp\_finite\_horizon}{Solves finite-horizon MDP using backwards induction algorithm}{mdp.Rul.finite.Rul.horizon}
%
\begin{Description}\relax
Solves finite-horizon MDP with backwards induction algorithm
\end{Description}
%
\begin{Usage}
\begin{verbatim}
mdp_finite_horizon(P, R, discount, N, h)
\end{verbatim}
\end{Usage}
%
\begin{Arguments}
\begin{ldescription}
\item[\code{P}] 
transition probability array. P can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S].

\item[\code{R}] 
reward array. R can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S] or a 2 dimensional matrix [S,A] possibly sparse.

\item[\code{discount}] 
discount factor. discount is a real number which belongs to [0; 1[.

\item[\code{N}] 
number of stages. N is an integer greater than 0.

\item[\code{h}] (optional) terminal reward. h is a S length vector. By default, h = numeric(S).

\end{ldescription}
\end{Arguments}
%
\begin{Details}\relax
mdp\_finite\_horizon applies backwards induction algorithm for finite-horizon MDP. The optimality equations allow to recursively evaluate function values starting from the terminal stage. This function uses verbose and silent modes. In verbose mode, the function displays the current stage and the corresponding optimal policy.
\end{Details}
%
\begin{Value}


\begin{ldescription}
\item[\code{V}] value fonction. V is a [S,(N+1)] matrix. Each column n is the optimal value fonction at stage n, with n = 1, ... N. V[,N+1] is the terminal reward.
\item[\code{policy}] optimal policy. policy is a [S,N] matrix. Each element is an integer correspond- ing to an action and each column n is the optimal policy at stage n.
\item[\code{cpu\_time}] CPU time used to run the program
\end{ldescription}

\end{Value}
%
\begin{Examples}
\begin{ExampleCode}

# With a non-sparse matrix
P <- array(0, c(2,2,2))
P[,,1] <- matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE)
P[,,2] <- matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE)
R <- matrix(c(5, 10, -1, 2), 2, 2, byrow=TRUE)
mdp_finite_horizon(P, R, 0.9, 3)

# With a sparse matrix
P <- list()
P[[1]] <- Matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE, sparse=TRUE)
P[[2]] <- Matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE, sparse=TRUE)
mdp_finite_horizon(P, R, 0.9, 3)
\end{ExampleCode}
\end{Examples}
\inputencoding{utf8}
\HeaderA{mdp\_LP}{Solves discounted MDP using linear programming algorithm}{mdp.Rul.LP}
%
\begin{Description}\relax
Solves discounted MDP with linear programming
\end{Description}
%
\begin{Usage}
\begin{verbatim}
mdp_LP(P, R, discount)
\end{verbatim}
\end{Usage}
%
\begin{Arguments}
\begin{ldescription}
\item[\code{P}] 
transition probability array. P is a 3 dimensions array [S,S,A]. Sparse matrix are not supported.

\item[\code{R}] 
reward array. R can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S] or a 2 dimensional matrix [S,A] possibly sparse.

\item[\code{discount}] 
discount factor. discount is a real which belongs to ]0; 1[

\end{ldescription}
\end{Arguments}
%
\begin{Details}\relax
mdp\_LP applies linear programming to solve discounted MDP for non-sparse matrix only.
\end{Details}
%
\begin{Value}


\begin{ldescription}
\item[\code{V}] optimal value fonction. V is a S length vector
\item[\code{policy }] optimal policy. policy is a S length vector. Each element is an integer corresponding to an action which maximizes the value function
\item[\code{cpu\_time}] CPU time used to run the program
\end{ldescription}

\end{Value}
%
\begin{Examples}
\begin{ExampleCode}
# Only with a non-sparse matrix
P <- array(0, c(2,2,2))
P[,,1] <- matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE)
P[,,2] <- matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE)
R <- matrix(c(5, 10, -1, 2), 2, 2, byrow=TRUE)
mdp_LP(P, R, 0.9)
\end{ExampleCode}
\end{Examples}
\inputencoding{utf8}
\HeaderA{mdp\_policy\_iteration}{Solves discounted MDP using policy iteration algorithm}{mdp.Rul.policy.Rul.iteration}
%
\begin{Description}\relax
Solves discounted MDP with policy iteration algorithm
\end{Description}
%
\begin{Usage}
\begin{verbatim}
mdp_policy_iteration(P, R, discount, policy0, max_iter, eval_type)
\end{verbatim}
\end{Usage}
%
\begin{Arguments}
\begin{ldescription}
\item[\code{P}] 
transition probability array. P can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S].

\item[\code{R}] 
reward array. R can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S] or a 2 dimensional matrix [S,A] possibly sparse.

\item[\code{discount}] 
discount factor.
discount is a real which belongs to ]0; 1[.

\item[\code{policy0}] (optional) starting policy. policy0 is a S length vector. By default, policy0 is the policy which maximizes the expected immediate reward.

\item[\code{max\_iter}] (optional)
maximum number of iterations to be done.
max\_iter is an integer greater than 0. 
By default, max\_iter is set to 1000.

\item[\code{eval\_type}] (optional)
define function used to evaluate a policy.
eval\_type is 0 for mdp\_eval\_policy\_matrix use, mdp\_eval\_policy\_iterative is used in all other cases. 
By default, eval\_type is set to 0.

\end{ldescription}
\end{Arguments}
%
\begin{Details}\relax
mdp\_policy\_iteration applies the policy iteration algorithm to solve discounted MDP. The algorithm consists in improving the policy iteratively, using the evaluation of the current policy. Iterating is stopped when two successive policies are identical or when a specified number (max\_iter) of iterations have been performed.
\end{Details}
%
\begin{Value}


\begin{ldescription}
\item[\code{V}] optimal value fonction. V is a S length vector
\item[\code{policy}] optimal policy. policy is a S length vector. Each element is an integer corre-
sponding to an action which maximizes the value function
\item[\code{iter}] number of iterations
\item[\code{cpu\_time}] CPU time used to run the program
\end{ldescription}
\end{Value}
%
\begin{Examples}
\begin{ExampleCode}
# With a non-sparse matrix
P <- array(0, c(2,2,2))
P[,,1] <- matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE)
P[,,2] <- matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE)
R <- matrix(c(5, 10, -1, 2), 2, 2, byrow=TRUE)
mdp_policy_iteration(P, R, 0.9)

# With a sparse matrix
P <- list()
P[[1]] <- Matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE, sparse=TRUE)
P[[2]] <- Matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE, sparse=TRUE)
mdp_policy_iteration(P, R, 0.9)

\end{ExampleCode}
\end{Examples}
\inputencoding{utf8}
\HeaderA{mdp\_policy\_iteration\_modified}{Solves discounted MDP using modified policy iteration algorithm}{mdp.Rul.policy.Rul.iteration.Rul.modified}
%
\begin{Description}\relax
Solves discounted MDP using modified policy iteration algorithm
\end{Description}
%
\begin{Usage}
\begin{verbatim}
mdp_policy_iteration_modified(P, R, discount, epsilon, max_iter)
\end{verbatim}
\end{Usage}
%
\begin{Arguments}
\begin{ldescription}
\item[\code{P}] 
transition probability array. P can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S].

\item[\code{R}] 
reward array. R can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S] or a 2 dimensional matrix [S,A] possibly sparse.

\item[\code{discount}] 
discount factor. discount is a real number which belongs to [0; 1[. For discount equals to 1, a warning recalls to check conditions of convergence.

\item[\code{epsilon}] (optional)
search for an epsilon-optimal policy. epsilon is a real in ]0; 1]. By default, epsilon = 0.01.

\item[\code{max\_iter}] (optional)
maximum number of iterations to be done. max\_iter is an integer greater than 0. By default, max\_iter = 1000.

\end{ldescription}
\end{Arguments}
%
\begin{Details}\relax
mdp\_policy\_iteration\_modified applies the modified policy iteration algorithm to solve discounted MDP. The algorithm consists, like policy iteration one, in improving the policy iteratively but in policy evaluation few iterations (max\_iter) of value function updates done. Iterating is stopped when an epsilon-optimal policy is found.
\end{Details}
%
\begin{Value}


\begin{ldescription}
\item[\code{V }] optimal value fonction. V is a S length vector
\item[\code{policy }] optimal policy. policy is a S length vector. Each element is an integer corresponding to an action which maximizes the value function.
\item[\code{iter }] number of iterations
\item[\code{cpu\_time }] CPU time used to run the program

\end{ldescription}

\end{Value}
%
\begin{Examples}
\begin{ExampleCode}
# With a non-sparse matrix
P <- array(0, c(2,2,2))
P[,,1] <- matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE)
P[,,2] <- matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE)
R<- matrix(c(5, 10, -1, 2), 2, 2, byrow=TRUE)
mdp_policy_iteration_modified(P, R, 0.9)

# With a sparse matrix
P <- list()
P[[1]] <- Matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE, sparse=TRUE)
P[[2]] <- Matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE, sparse=TRUE)
mdp_policy_iteration_modified(P, R, 0.9)

\end{ExampleCode}
\end{Examples}
\inputencoding{utf8}
\HeaderA{mdp\_Q\_learning}{Solves discounted MDP using the Q-learning algorithm (Reinforcement Learning)}{mdp.Rul.Q.Rul.learning}
%
\begin{Description}\relax
Solves discounted MDP with the Q-learning algorithm (Reinforcement learning)
\end{Description}
%
\begin{Usage}
\begin{verbatim}
mdp_Q_learning(P, R, discount, N)
\end{verbatim}
\end{Usage}
%
\begin{Arguments}
\begin{ldescription}
\item[\code{P}] 
transition probability array. P can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S].

\item[\code{R}] 
reward array. R can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S] or a 2 dimensional matrix [S,A] possibly sparse.

\item[\code{discount}] 
discount factor.
discount is a real which belongs to ]0; 1[

\item[\code{N}] 
(optional) : number of iterations to perform.
N is an integer that must be greater than the default value.
By default, N is set to 10000.

\end{ldescription}
\end{Arguments}
%
\begin{Details}\relax
mdp\_Q\_learning computes the Q matrix, the mean discrepancy and gives the optimal value function and the optimal policy when allocated enough iterations. It uses an iterative method.
\end{Details}
%
\begin{Value}


\begin{ldescription}
\item[\code{Q }] an action-value function that gives the expected utility of taking a given action in a given state and following an optimal policy thereafter. Q is a [S,A] matrix.
\item[\code{mean\_discrepancy }] discrepancy means over 100 iterations. mean\_discrepancy is a vector of V discrepancy mean over 100 iterations. Then the length of the vector for the default value of N is 100.
\item[\code{V }] value function. V is a S length vector.
\item[\code{policy }] policy. policy is a S length vector. Each element is an integer corresponding to an action which maximizes the value function
\end{ldescription}

\end{Value}
%
\begin{Examples}
\begin{ExampleCode}

# With a non-sparse matrix
P <- array(0, c(2,2,2))
P[,,1] <- matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE)
P[,,2] <- matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE)
R <- matrix(c(5, 10, -1, 2), 2, 2, byrow=TRUE)
# Not run
# mdp_Q_learning(P, R, 0.9)

# With a sparse matrix
P <- list()
P[[1]] <- Matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE, sparse=TRUE)
P[[2]] <- Matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE, sparse=TRUE)
# Not run
# mdp_Q_learning(P, R, 0.9)

\end{ExampleCode}
\end{Examples}
\inputencoding{utf8}
\HeaderA{mdp\_relative\_value\_iteration}{Solves MDP with average reward using relative value iteration algorithm}{mdp.Rul.relative.Rul.value.Rul.iteration}
%
\begin{Description}\relax
Solves MDP with average reward using relative value iteration algorithm
\end{Description}
%
\begin{Usage}
\begin{verbatim}
mdp_relative_value_iteration(P, R, epsilon, max_iter)
\end{verbatim}
\end{Usage}
%
\begin{Arguments}
\begin{ldescription}
\item[\code{P}] 
transition probability array. P can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S].

\item[\code{R}] 
reward array. R can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S] or a 2 dimensional matrix [S,A] possibly sparse.

\item[\code{epsilon}] 
(optional) : search for an epsilon-optimal policy.
epsilon is a real in [0; 1]. 
By default, epsilon is set to 0.01

\item[\code{max\_iter}] 
(optional) : maximum number of iterations.
max\_iter is an integer greater than 0. 
By default, max\_iter is set to 1000.

\end{ldescription}
\end{Arguments}
%
\begin{Details}\relax
mdp\_relative\_value\_iteration applies the relative value iteration algorithm to solve MDP with average reward. The algorithm consists in solving optimality equations iteratively. Iterating is stopped when an epsilon-optimal policy is found or after a specified number (max\_iter) of iterations is done.
\end{Details}
%
\begin{Value}


\begin{ldescription}
\item[\code{policy }] optimal policy. policy is a S length vector. Each element is an integer corresponding to an action which maximizes the value function.
\item[\code{average\_reward }] average reward of the optimal policy. average\_reward is a real.
\item[\code{cpu\_time }] CPU time used to run the program
\end{ldescription}

\end{Value}
%
\begin{Examples}
\begin{ExampleCode}

# With a non-sparse matrix
P <- array(0, c(2,2,2))
P[,,1] <- matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE)
P[,,2] <- matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE)
R <- matrix(c(5, 10, -1, 2), 2, 2, byrow=TRUE)
mdp_relative_value_iteration(P, R)

# With a sparse matrix
P <- list()
P[[1]] <- Matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE, sparse=TRUE)
P[[2]] <- Matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE, sparse=TRUE)
mdp_relative_value_iteration(P, R)

\end{ExampleCode}
\end{Examples}
\inputencoding{utf8}
\HeaderA{mdp\_span}{Evaluates the span of a vector}{mdp.Rul.span}
%
\begin{Description}\relax
Computes the span of a vector.
\end{Description}
%
\begin{Usage}
\begin{verbatim}
mdp_span(W)
\end{verbatim}
\end{Usage}
%
\begin{Arguments}
\begin{ldescription}
\item[\code{W}] 
a vector.

\end{ldescription}
\end{Arguments}
%
\begin{Details}\relax
mdp\_span computes the span of the W vector: max W(s) - min W(s)
\end{Details}
%
\begin{Value}
the value of the span of the W vector.
\end{Value}
\inputencoding{utf8}
\HeaderA{mdp\_value\_iteration}{Solves discounted MDP using value iteration algorithm}{mdp.Rul.value.Rul.iteration}
%
\begin{Description}\relax
Solves discounted MDP with value iteration algorithm
\end{Description}
%
\begin{Usage}
\begin{verbatim}
mdp_value_iteration(P, R, discount, epsilon, max_iter, V0)
\end{verbatim}
\end{Usage}
%
\begin{Arguments}
\begin{ldescription}
\item[\code{P}] 
transition probability array. P can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S].

\item[\code{R}] 
reward array. R can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S] or a 2 dimensional matrix [S,A] possibly sparse.

\item[\code{discount}] 
discount factor. discount is a real number which belongs to [0; 1[.
For discount equals to 1, a warning recalls to check conditions of convergence.

\item[\code{epsilon}] 
(optional) : search for an epsilon-optimal policy.
epsilon is a real in ]0; 1].
By default, epsilon = 0.01.

\item[\code{max\_iter}] 
(optional) : maximum number of iterations.
max\_iter is an integer greater than 0. If the value given in argument is greater than a computed bound, a warning informs that the computed bound will be considered.
By default, if discount is not egal to 1, a bound for max\_iter is computed, if not max\_iter = 1000.

\item[\code{V0}] 
(optional) : starting value function.
V0 is a (Sx1) vector.
By default, V0 is only composed of 0 elements.

\end{ldescription}
\end{Arguments}
%
\begin{Details}\relax
mdp\_value\_iteration applies the value iteration algorithm to solve discounted MDP. The algorithm consists in solving Bellman's equation iteratively. Iterating is stopped when an epsilon-optimal policy is found or after a specified number (max\_iter) of iterations.
\end{Details}
%
\begin{Value}


\begin{ldescription}
\item[\code{policy }] optimal policy.
policy is a S length vector. Each element is an integer corresponding to an action which maximizes the value function.
\item[\code{iter }] number of done iterations.
\item[\code{cpu\_time }] CPU time used to run the program.
\end{ldescription}

\end{Value}
%
\begin{Examples}
\begin{ExampleCode}

# With a non-sparse matrix
P <- array(0, c(2,2,2))
P[,,1] <- matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE)
P[,,2] <- matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE)
R<- matrix(c(5, 10, -1, 2), 2, 2, byrow=TRUE)
mdp_value_iteration(P, R, 0.9)

# With a sparse matrix
P <- list()
P[[1]] <- Matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE, sparse=TRUE)
P[[2]] <- Matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE, sparse=TRUE)
mdp_value_iteration(P, R, 0.9)

\end{ExampleCode}
\end{Examples}
\inputencoding{utf8}
\HeaderA{mdp\_value\_iterationGS}{Solves discounted MDP using Gauss-Seidel's value iteration algorithm}{mdp.Rul.value.Rul.iterationGS}
%
\begin{Description}\relax
Solves discounted MDP with Gauss-Seidel's value iteration algorithm.
\end{Description}
%
\begin{Usage}
\begin{verbatim}
mdp_value_iterationGS(P, R, discount, epsilon, max_iter, V0)
\end{verbatim}
\end{Usage}
%
\begin{Arguments}
\begin{ldescription}
\item[\code{P}] 
transition probability array. P can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S].

\item[\code{R}] 
reward array. R can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S] or a 2 dimensional matrix [S,A] possibly sparse.

\item[\code{discount}] 
discount factor.
discount is a real which belongs to ]0; 1].
For discount equals to 1, a warning recalls to check conditions of convergence.

\item[\code{epsilon}] 
(optional) : search of an epsilon-optimal policy.
epsilon is a real in ]0; 1].
By default, epsilon is set to 0.01.

\item[\code{max\_iter}] 
(optional) : maximum number of iterations to be done.
max\_iter is an integer greater than 0. If the value given in argument is greater than a computed bound, a warning informs that the computed bound will be considered.
By default, if discount is not equal to 1, a bound for max\_iter is computed, if not max\_iter is set to 1000.

\item[\code{V0}] 
(optional) : starting value function.
V0 is a S length vector.
By default, V0 is only composed of 0 elements.

\end{ldescription}
\end{Arguments}
%
\begin{Details}\relax
mdp\_value\_iterationGS applies Gauss-Seidel's value iteration algorithm to solve discounted MDP. The algorithm consists, like value iteration, in solving Bellman's equation iteratively Vn+1(s) calculation is modified. The algorithm uses Vn+1(s) instead of Vn(s) whenever this value has been calculated. In this way, convergence speed is improved. Iterating is stopped when an epsilon-optimal policy is found or after a specified number (max\_iter) of iterations.
\end{Details}
%
\begin{Value}


\begin{ldescription}
\item[\code{policy }] epsilon-optimal policy.
policy is a S length vector. Each element is an integer corresponding to an action which maximizes the value function.
\item[\code{iter }] number of done iterations.
\item[\code{cpu\_time }] CPU time used to run the program.
\end{ldescription}

\end{Value}
%
\begin{Examples}
\begin{ExampleCode}
# With a non-sparse matrix
P <- array(0, c(2,2,2))
P[,,1] <- matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE)
P[,,2] <- matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE)
R <- matrix(c(5, 10, -1, 2), 2, 2, byrow=TRUE)
mdp_value_iterationGS(P, R, 0.9)

# With a sparse matrix
P <- list()
P[[1]] <- Matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE, sparse=TRUE)
P[[2]] <- Matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE, sparse=TRUE)
mdp_value_iterationGS(P, R, 0.9)

\end{ExampleCode}
\end{Examples}
\inputencoding{utf8}
\HeaderA{mdp\_value\_iteration\_bound\_iter}{Computes a bound for the number of iterations for the value iteration algorithm}{mdp.Rul.value.Rul.iteration.Rul.bound.Rul.iter}
%
\begin{Description}\relax
Computes a bound on the number of iterations for the value iteration algorithm
\end{Description}
%
\begin{Usage}
\begin{verbatim}
mdp_value_iteration_bound_iter(P, R, discount, epsilon, V0)
\end{verbatim}
\end{Usage}
%
\begin{Arguments}
\begin{ldescription}
\item[\code{P}] 
transition probability array. P can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S].

\item[\code{R}] 
reward array. R can be a 3 dimensions array [S,S,A] or a list [[A]], each element containing a sparse matrix [S,S] or a 2 dimensional matrix [S,A] possibly sparse.

\item[\code{discount}] 
discount factor.
discount is a real which belongs to ]0; 1[.

\item[\code{epsilon}] 
(optional) : search for an epsilon-optimal policy
epsilon is a real in ]0; 1]. 
By default, epsilon is set to 0.01.

\item[\code{V0}] 
(optional) : starting value function.
V0 is a S length vector.
By default, V0 is only composed of 0 elements.

\end{ldescription}
\end{Arguments}
%
\begin{Details}\relax
mdp\_value\_iteration\_bound\_iter computes a bound on the number of iterations for the value iteration algorithm to find an epsilon-optimal policy with use of span for the stopping criterion.
\end{Details}
%
\begin{Value}


\begin{ldescription}
\item[\code{max\_iter }] maximum number of iterations to be done.
max\_iter is an integer greater than 0.
\item[\code{cpu\_time }] CPU time used to run the program.
\end{ldescription}

\end{Value}
%
\begin{Examples}
\begin{ExampleCode}
# With a non-sparse matrix
P <- array(0, c(2,2,2))
P[,,1] <- matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE)
P[,,2] <- matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE)
R <- matrix(c(5, 10, -1, 2), 2, 2, byrow=TRUE)
mdp_value_iteration_bound_iter(P, R, 0.9)

# With a sparse matrix
P <- list()
P[[1]] <- Matrix(c(0.5, 0.5, 0.8, 0.2), 2, 2, byrow=TRUE, sparse=TRUE)
P[[2]] <- Matrix(c(0, 1, 0.1, 0.9), 2, 2, byrow=TRUE, sparse=TRUE)
mdp_value_iteration_bound_iter(P, R, 0.9)

\end{ExampleCode}
\end{Examples}
\printindex{}
\end{document}
